/*
 * Copyright (c) 2018 Nordic Semiconductor ASA
 *
 * SPDX-License-Identifier: LicenseRef-BSD-5-Clause-Nordic
 */

#include <zephyr.h>
#include <stdio.h>
#include <uart.h>
#include <string.h>

//functions like send() and rev() is declared here
#include <net/socket.h>


static int common_socket_fd;
int bytes_sent;
int bytes_read;
static u8_t at_buf[256] = "AT+CGMI\r\n";
static u8_t at_cfun[256] = "AT+CFUN=4\r\n";

static char buf[256];

void main(void)
{
      	common_socket_fd = socket(AF_LTE, 0, NPROTO_AT);

	if (common_socket_fd == -1) {
		printk("Could not open socket\n");
	} else {
            printk("Could open socket\n");
        }

        struct timeval tv;
        tv.tv_sec = 1;
        tv.tv_usec = 0;
        setsockopt(common_socket_fd, SOL_SOCKET, SO_RCVTIMEO, (const char*)&tv, sizeof tv);

      
      int bytes_to_send = strlen(at_cfun);

      bytes_sent = send(common_socket_fd, at_cfun, bytes_to_send, 0);
      if (bytes_sent != bytes_to_send) {
		printk("Failed to send AT command,should send %d bytes. Bytes sent is %d\n", bytes_to_send, bytes_sent);
      } else{
                printk("AT command succeeded, should send %d bytes. Bytes sent is %d\n", bytes_to_send, bytes_sent);
      }
      bytes_read = recv(common_socket_fd, buf, sizeof(buf), 0);
      printk("RECEIVED FROM recv(): %s\n", buf);


      printk("The AT Understand sample started\n");
}